/*
 * mtch112.h
 *
 *  Created on: 21.12.2018
 *      Author: PLARZAW1
 */

#ifndef DEVICES_INC_MTCH112_H_
#define DEVICES_INC_MTCH112_H_

#include <stdbool.h>
#include "../../../Utilities/Inc/errors.h"
#include "ic_devices.h"


typedef enum
{
	MTCH112_STATE_BOTH_OK,
	MTCH112_STATE_SEN0_SHORTED_VDD,
	MTCH112_STATE_SEN1_SHORTED_VDD,
	MTCH112_STATE_SEN0_SHORTED_VSS,
	MTCH112_STATE_SEN1_SHORTED_VSS,
	MTCH112_STATE_BOTH_SHORTED_TOGETHER
}mtch112_error_state_t;



#define MTCH112_REG_ADDR__OUTCON 								0x01

	#define MTCH112_REG_MASK__OUTCON__S1POE 		  			0x08
	#define MTCH112_REG_VALUE__OUTCON__S1POE__ENABLE 			0x08
	#define MTCH112_REG_VALUE__OUTCON__S1POE__DISABLE 			0x00

	#define MTCH112_REG_MASK__OUTCON__S0POE		 				0x04
	#define MTCH112_REG_VALUE__OUTCON__S0POE__ENABLE 			0x04
	#define MTCH112_REG_VALUE__OUTCON__S0POE__DISABLE 			0x00

	#define MTCH112_REG_MASK__OUTCON__S1BOE 					0x02
	#define MTCH112_REG_VALUE__OUTCON__S1BOE__ENABLE 			0x02
	#define MTCH112_REG_VALUE__OUTCON__S1BOE__DISABLE 			0x00

	#define MTCH112_REG_MASK__OUTCON__S0BOE 					0x01
	#define MTCH112_REG_VALUE__OUTCON__S0BOE__ENABLE 			0x01
	#define MTCH112_REG_VALUE__OUTCON__S0BOE__DISABLE 			0x00

#define MTCH112_REG_ADDR__CALCON0 								0x02

	#define MTCH112_REG_MASK__CALCON0__S0WS 					0xC0
	#define MTCH112_REG_VALUE__CALCON0__S0WS__NORMAL			0x00
	#define MTCH112_REG_VALUE__CALCON0__S0WS__DOUBLE			0x40
	#define MTCH112_REG_VALUE__CALCON0__S0WS__HALF				0x80

	#define MTCH112_REG_MASK__CALCON0__S0CAL 					0x02
	#define MTCH112_REG_VALUE__CALCON0__S0CAL__COMPLETE 		0x02
	#define MTCH112_REG_VALUE__CALCON0__S0CAL__REQUESTED		0x00

#define MTCH112_REG_ADDR__CALCON1 		0x03

	#define MTCH112_REG_MASK__CALCON1__S1WS 					0xC0
	#define MTCH112_REG_VALUE__CALCON1__S1WS__NORMAL			0x00
	#define MTCH112_REG_VALUE__CALCON1__S1WS__DOUBLE			0x40
	#define MTCH112_REG_VALUE__CALCON1__S1WS__HALF				0x80

	#define MTCH112_REG_MASK__CALCON1__S1CAL 					0x02
	#define MTCH112_REG_VALUE__CALCON1__S1CAL__COMPLETE 		0x02
	#define MTCH112_REG_VALUE__CALCON1__S1CAL__REQUESTED		0x00

	#define MTCH112_REG_MASK__CALCON1__S1EN 					0x01
	#define MTCH112_REG_VALUE__CALCON1__S1EN__ENABLED 			0x01
	#define MTCH112_REG_VALUE__CALCON1__S1EN__DISABLED			0x00

#define MTCH112_REG_ADDR__ADACQ0 								0x04

	#define MTCH112_REG_MASK__ADACQ0__S0ACQ						0x1F

#define MTCH112_REG_ADDR__ADACQ1 								0x05

	#define MTCH112_REG_MASK__ADACQ1__S1ACQ						0x1F

#define MTCH112_REG_ADDR__LPCON 								0x06

	#define MTCH112_REG_MASK__LPCON__SLEEP 						0x3E
	#define MTCH112_REG_VALUE__LPCON__SLEEP__1MS				0x00
	#define MTCH112_REG_VALUE__LPCON__SLEEP__2MS				0x02
	#define MTCH112_REG_VALUE__LPCON__SLEEP__4MS				0x04
	#define MTCH112_REG_VALUE__LPCON__SLEEP__8MS				0x06
	#define MTCH112_REG_VALUE__LPCON__SLEEP__16MS				0x08
	#define MTCH112_REG_VALUE__LPCON__SLEEP__32MS				0x0A
	#define MTCH112_REG_VALUE__LPCON__SLEEP__64MS				0x0C
	#define MTCH112_REG_VALUE__LPCON__SLEEP__128MS				0x0E
	#define MTCH112_REG_VALUE__LPCON__SLEEP__256MS				0x10
	#define MTCH112_REG_VALUE__LPCON__SLEEP__512MS				0x12
	#define MTCH112_REG_VALUE__LPCON__SLEEP__1S	  				0x14
	#define MTCH112_REG_VALUE__LPCON__SLEEP__2S					0x16
	#define MTCH112_REG_VALUE__LPCON__SLEEP__4S					0x18
	#define MTCH112_REG_VALUE__LPCON__SLEEP__8S					0x1A
	#define MTCH112_REG_VALUE__LPCON__SLEEP__16S				0x1C
	#define MTCH112_REG_VALUE__LPCON__SLEEP__32S				0x1E
	#define MTCH112_REG_VALUE__LPCON__SLEEP__64S				0x20
	#define MTCH112_REG_VALUE__LPCON__SLEEP__128S				0x22
	#define MTCH112_REG_VALUE__LPCON__SLEEP__256S				0x24

	#define MTCH112_REG_MASK__LPCON__CLKSEL						0x01
	#define MTCH112_REG_VALUE__LPCON__CLKSEL__32MHZ				0x01
	#define MTCH112_REG_VALUE__LPCON__CLKSEL__16MHZ				0x00

#define MTCH112_REG_ADDR__PRESS_THRESH							0x07
#define MTCH112_REG_ADDR__PROX_THRESH							0x08
#define MTCH112_REG_ADDR__TIMEOUT_L  							0x09
#define MTCH112_REG_ADDR__TIMEOUT_H 							0x0A
#define MTCH112_REG_ADDR__I2CADDR   							0x0B

#define MTCH112_REG_ADDR__STATE     							0x80

	#define MTCH112_REG_MASK__STATE__ERRSTATE			     	0x70
	#define MTCH112_REG_VALUE__STATE__BOTH_OK			     	0x00
	#define MTCH112_REG_VALUE__STATE__SEN0_SHORTED_VDD	     	0x10
	#define MTCH112_REG_VALUE__STATE__SEN1_SHORTED_VDD	     	0x20
	#define MTCH112_REG_VALUE__STATE__SEN0_SHORTED_VSS	     	0x30
	#define MTCH112_REG_VALUE__STATE__SEN1_SHORTED_VSS	     	0x40
	#define MTCH112_REG_VALUE__STATE__BOTH_SHORTED_TOGETHER    	0x50

	#define MTCH112_REG_MASK__STATE__S1PS				     	0x08
	#define MTCH112_REG_VALUE__STATE__S1PS__NO_DETECTED	     	0x00
	#define MTCH112_REG_VALUE__STATE__S1PS__DETECTED	     	0x08

	#define MTCH112_REG_MASK__STATE__S0PS				     	0x04
	#define MTCH112_REG_VALUE__STATE__S0PS__NO_DETECTED	     	0x00
	#define MTCH112_REG_VALUE__STATE__S0PS__DETECTED	     	0x04

	#define MTCH112_REG_MASK__STATE__S1BS				     	0x02
	#define MTCH112_REG_VALUE__STATE__S1BS__NO_DETECTED	     	0x00
	#define MTCH112_REG_VALUE__STATE__S1BS__DETECTED	     	0x02

	#define MTCH112_REG_MASK__STATE__S0BS				     	0x01
	#define MTCH112_REG_VALUE__STATE__S0BS__NO_DETECTED	     	0x00
	#define MTCH112_REG_VALUE__STATE__S0BS__DETECTED	     	0x01

#define MTCH112_REG_ADDR__READING0L		0x81
#define MTCH112_REG_ADDR__READING0H		0x82
#define MTCH112_REG_ADDR__READING1L		0x83
#define MTCH112_REG_ADDR__READING1H		0x84
#define MTCH112_REG_ADDR__BASELINE0L	0x85
#define MTCH112_REG_ADDR__BASEFINE0H	0x86
#define MTCH112_REG_ADDR__BASELINE1L	0x87
#define MTCH112_REG_ADDR__BASELINE1H	0x88




err_code_t mtch112_Init(ic_address_t device);
err_code_t mtch112_WhoAmI(ic_address_t device);
err_code_t mtch112_ReadState(ic_address_t device,
		                     mtch112_error_state_t *error_state,
							 bool *sen0_btn,
							 bool *sen1_btn,
							 bool *sen0_pxm,
							 bool *sen1_pxm);

#endif /* DEVICES_INC_MTCH112_H_ */
